

// APT-generated file.

package org.carrot2.source.yahoo;

//Imported for JavaDoc references mostly.
import org.carrot2.util.attribute.*;

import java.util.*;
import javax.annotation.*;

/**
 * Metadata and attributes of the {@link org.carrot2.source.yahoo.YahooNewsSearchService} component. You can use 
 * this descriptor to obtain metadata, such as human readable name and description, about the component 
 * as a whole as well as about its attributes. Using the {@link #attributeBuilder(Map)}
 * you can obtain a builder for type-safe generation of the attribute maps. Please see the
 * <a href="{@docRoot}/overview-summary.html#setting-attributes">main overview</a> for a complete code example. 
 */
@Generated("Generated from org.carrot2.source.yahoo.YahooNewsSearchService")
public final class YahooNewsSearchServiceDescriptor implements IBindableDescriptor
{
    /**
     * The component class for which this descriptor was generated. 
     */
    public final String bindableClassName = "org.carrot2.source.yahoo.YahooNewsSearchService";

    /**
     * Attribute prefix used by the component.
     */
    public final String prefix = "YahooNewsSearchService";

    /**
     * A one sentence summary of the component. It could be presented as a header of the tool
     * tip of the corresponding UI component.
     */
    public final String title = "Sends queries to Yahoo! News search service";
    
    /**
     * A short label for the component. It can be presented as a label of the
     * corresponding UI component.
     */
    public final String label = "Yahoo News Search Service";

    /**
     * A longer, possibly multi sentence, description of the component. It could be presented
     * as a body of the tool tip of the corresponding UI component.
     */
    public final String description = "Instances of this class are thread-safe. <p> Attributes of this class correspond to Yahoo's documentation (see links below).";

    /**
     * Attributes of the component. Note that only statically reachable fields are included.
     * Additional attributes may be available at run time. 
     */
    public final static Attributes attributes; 

    /**
     * Attributes declared directly by the component.
     */
    private final static Set<AttributeInfo> ownAttributes;

    /**
     * Attributes declared by the component or its superclasses.
     */
    private final static Set<AttributeInfo> allAttributes;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary 
     * by attribute key.
     */
    private final static Map<String, AttributeInfo> allAttributesByKey;

    /**
     * Attributes declared by the component or its superclasses, lookup dictionary by 
     * attribute's field name.
     */
    private final static Map<String, AttributeInfo> allAttributesByFieldName;

    /**
     * Static initializer for internal collections.
     */
    static
    {
        attributes = new Attributes();

        final Set<AttributeInfo> ownAttrs = new HashSet<AttributeInfo>();
        ownAttrs.add(attributes.serviceURI);
        ownAttrs.add(attributes.site);
        ownAttrs.add(attributes.sort);

        final Set<AttributeInfo> allAttrs = new HashSet<AttributeInfo>();
        allAttrs.add(org.carrot2.source.yahoo.YahooNewsSearchServiceDescriptor.attributes.serviceURI);
        allAttrs.add(org.carrot2.source.yahoo.YahooNewsSearchServiceDescriptor.attributes.site);
        allAttrs.add(org.carrot2.source.yahoo.YahooNewsSearchServiceDescriptor.attributes.sort);
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.appid);
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.type);
        allAttrs.add(org.carrot2.source.yahoo.YahooSearchServiceDescriptor.attributes.language);

        allAttributes = Collections.unmodifiableSet(allAttrs);
        ownAttributes = Collections.unmodifiableSet(ownAttrs);
        
        final Map<String, AttributeInfo> allAttrsByKey = new HashMap<String, AttributeInfo>();
        final Map<String, AttributeInfo> allAttrsByFieldName = new HashMap<String, AttributeInfo>();
        for (AttributeInfo ai : allAttrs)
        {
            allAttrsByKey.put(ai.key, ai);
            allAttrsByFieldName.put(ai.fieldName, ai);
        }

        allAttributesByKey = Collections.unmodifiableMap(allAttrsByKey);
        allAttributesByFieldName = Collections.unmodifiableMap(allAttrsByFieldName);
    }

    
    /* Attribute keys. */

    /**
     * Constants for all attribute keys of the {@link org.carrot2.source.yahoo.YahooNewsSearchService} component.
     */
    public static class Keys  extends org.carrot2.source.yahoo.YahooSearchServiceDescriptor.Keys 
    {
        protected Keys() {} 

        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooNewsSearchService#serviceURI}. */
        public static final String SERVICE_URI = "YahooNewsSearchService.serviceURI";
        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooNewsSearchService#site}. */
        public static final String SITE = "YahooNewsSearchService.site";
        /** Attribute key for: {@link org.carrot2.source.yahoo.YahooNewsSearchService#sort}. */
        public static final String SORT = "YahooNewsSearchService.sort";
    }


    /* Attribute descriptors. */

    /**
     * All attributes of the {@link org.carrot2.source.yahoo.YahooNewsSearchService} component.
     */
    public static final class Attributes
    {
        private Attributes() { /* No public instances. */ }

        /**
         *          */
        public final AttributeInfo serviceURI = 
            new AttributeInfo(
                "YahooNewsSearchService.serviceURI",
                "org.carrot2.source.yahoo.YahooNewsSearchService",
                "serviceURI",
                "Yahoo! service URI to be queried.",
                "Service URI",
                "Yahoo! service URI to be queried",
                null,
                "Service",
                org.carrot2.util.attribute.AttributeLevel.ADVANCED,
                null
            );

        /**
         *          */
        public final AttributeInfo site = 
            new AttributeInfo(
                "YahooNewsSearchService.site",
                "org.carrot2.source.yahoo.YahooNewsSearchService",
                "site",
                "A domain to restrict your searches to (e.g., www.yahoo.com).",
                "Domain restriction",
                "A domain to restrict your searches to (e.g., www.yahoo.com)",
                null,
                "Results filtering",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );

        /**
         *          */
        public final AttributeInfo sort = 
            new AttributeInfo(
                "YahooNewsSearchService.sort",
                "org.carrot2.source.yahoo.YahooNewsSearchService",
                "sort",
                "Results sort order.",
                "Sorting order",
                "Results sort order",
                null,
                "Results sorting",
                org.carrot2.util.attribute.AttributeLevel.MEDIUM,
                null
            );


    }

    /**
     * Attribute map builder for the  {@link org.carrot2.source.yahoo.YahooNewsSearchService} component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     */
    public static class AttributeBuilder  extends org.carrot2.source.yahoo.YahooSearchServiceDescriptor.AttributeBuilder 
    {
        /** The attribute map populated by this builder. */
        public final Map<String, Object> map;

        /**
         * Creates a builder backed by the provided map.
         */
        protected AttributeBuilder(Map<String, Object> map)
        {
             super(map); 
            this.map = map;
        }


        
        
        /**
         * Yahoo! service URI to be queried.
         * 
         * @see org.carrot2.source.yahoo.YahooNewsSearchService#serviceURI 
         */
        public AttributeBuilder serviceURI(java.lang.String value)
        {
            map.put("YahooNewsSearchService.serviceURI", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * A domain to restrict your searches to (e.g., www.yahoo.com).
         * 
         * @see org.carrot2.source.yahoo.YahooNewsSearchService#site 
         */
        public AttributeBuilder site(java.lang.String value)
        {
            map.put("YahooNewsSearchService.site", value);
            return this;
        }
        
        
        
        
        
        
        
        /**
         * Results sort order.
         * 
         * @see org.carrot2.source.yahoo.YahooNewsSearchService#sort 
         */
        public AttributeBuilder sort(org.carrot2.source.yahoo.YahooNewsSearchService.SortType value)
        {
            map.put("YahooNewsSearchService.sort", value);
            return this;
        }
        
        
        
        /**
         * Results sort order.
         * 
         * @see org.carrot2.source.yahoo.YahooNewsSearchService#sort
         */
        public AttributeBuilder sort(Class<? extends org.carrot2.source.yahoo.YahooNewsSearchService.SortType> clazz)
        {
            map.put("YahooNewsSearchService.sort", clazz);
            return this;
        }
        
        
        
    }

    /**
     * Creates an attribute map builder for the component. You can use this
     * builder as a type-safe alternative to populating the attribute map using attribute keys.
     * 
     * @param attributeValues An existing map which should be used to collect attribute values. 
     *        Attribute values set by this builder will be added to the provided map, overwriting
     *        previously defined mappings, if any.
     */
    public static AttributeBuilder attributeBuilder(Map<String, Object> attributeValues)
    {
        return new AttributeBuilder(attributeValues);
    }
    
    /* IBindableDescriptor */

    @Override 
    public String getPrefix()
    {
        return prefix;
    }

    @Override 
    public String getTitle()
    {
        return title;
    }
    
    @Override 
    public String getLabel()      
    { 
        return label;
    }
    
    @Override 
    public String getDescription() 
    { 
        return description; 
    }

    @Override 
    public Set<AttributeInfo> getOwnAttributes()
    { 
        return ownAttributes;
    }

    @Override 
    public Set<AttributeInfo> getAttributes()
    {
        return allAttributes;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByKey()
    {
        return allAttributesByKey;
    }

    @Override 
    public Map<String, AttributeInfo> getAttributesByFieldName()
    {
        return allAttributesByFieldName;
    }
}
